﻿using System;
using System.Text;

namespace QR64Encoder
{
    public class QR64Encoder
    {
      
        public string Sec1 { get; set; }
        public string Sec2 { get; set; }
        public string Sec3 { get; set; }
        public string Sec4 { get; set; }
        public string Sec5 { get; set; }
        public QR64Encoder()
        {

        }

        private byte[] Encode2(int Index, string text)
        {
           
            byte[] third = UTF8Encoding.UTF8.GetBytes(text);
            byte[] first = BitConverter.GetBytes(Index);
            byte[] second = BitConverter.GetBytes(third.Length);

            byte[] ret = new byte[2 + third.Length];
            Buffer.BlockCopy(first, 0, ret, 0, 1);
            Buffer.BlockCopy(second, 0, ret, 1, 1);
            Buffer.BlockCopy(third, 0, ret, 2, third.Length);
            return ret;

        }
        private byte[] Combine(byte[] first, byte[] second, byte[] third)
        {
            byte[] ret = new byte[first.Length + second.Length + third.Length];
            Buffer.BlockCopy(first, 0, ret, 0, first.Length);
            Buffer.BlockCopy(second, 0, ret, first.Length, second.Length);
            Buffer.BlockCopy(third, 0, ret, first.Length + second.Length, third.Length);
            return ret;
        }

        public string Get64EncoderText()
        {
            byte[] a1 = Encode2(1, this.Sec1);
            byte[] a2 = Encode2(2, this.Sec2);
            byte[] a3 = Encode2(3, this.Sec3);
            byte[] a4 = Encode2(4, this.Sec4);
            byte[] a5 = Encode2(5, this.Sec5);


            byte[] ret = new byte[a1.Length + a2.Length + a3.Length + a4.Length + a5.Length];
            Buffer.BlockCopy(a1, 0, ret, 0, a1.Length);
            Buffer.BlockCopy(a2, 0, ret, a1.Length, a2.Length);
            Buffer.BlockCopy(a3, 0, ret, a1.Length + a2.Length, a3.Length);

            Buffer.BlockCopy(a4, 0, ret, a1.Length + a2.Length + a3.Length, a4.Length);
            Buffer.BlockCopy(a5, 0, ret, a1.Length + a2.Length + a3.Length + a4.Length, a5.Length);


            return  System.Convert.ToBase64String(ret);
        }
    }
}
